<?php

namespace LaraBB\Settings\UI\Web\Requests\Prefix;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\RedirectResponse;

/**
 * Class Store
 * @package LaraBB\Settings\UI\Web\Requests\Prefix
 */
class Store extends FormRequest
{
    /**
     * @return bool
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * @return array
     */
    public function rules(): array
    {
        return [
            'prefix'        => 'required|unique:settings_prefixes,prefix',
            'display_style' => 'required',
            'forums'        => 'required'
        ];
    }

    /**
     * @return array
     */
    public function messages(): array
    {
        return [
            'prefix.required'        => 'Bitte geben Sie einen Präfix an!',
            'prefix.unique'          => 'Dieser Präfix ist bereits vorhanden.',
            'display_style.required' => 'Bitte geben Sie einen Anzeigestil an!',
            'forums.required'        => 'Bitte geben Sie Foren an, in denen der Präfix verfügbar sein soll.'
        ];
    }

    /**
     * @return RedirectResponse
     */
    public function success(): RedirectResponse
    {
        return redirect()->route('admin.settings.prefix')->with([
            'success' => 'Der Präfix wurde erfolgreich erstellt.'
        ]);
    }

    /**
     * @return RedirectResponse
     */
    public function failed(): RedirectResponse
    {
        return redirect()->route('admin.settings-prefix.create')->with([
            'error' => 'Der Präfix konnte aufgrund einer technischen Störung nicht erstellt werden.'
        ])->withInput();
    }
}
